rm(list=ls())
source("WPS4D4Science.r")

#SERVICE PARAMETERS
wps_uri = "http://dataminer1-d-d4s.d4science.org:80/wps/WebProcessingService" #DEV "http://dataminer1-d-d4s.d4science.org:80/wps/WebProcessingService"
username<-"statistical.wps"
token<-"45943442-74ef-408b-be64-d26b42cf4c08" 
options(digits.secs=3)

#SAMPLE DESCRIPTION OF THE ALGORITHM IS HERE: 
#http://dataminer1-d-d4s.d4science.org/wps/WebProcessingService?Request=DescribeProcess&Service=WPS&Version=1.0.0&gcube-token=4ccc2c35-60c9-4c9b-9800-616538d5d48b&Identifier=org.gcube.dataanalysis.wps.statisticalmanager.synchserver.mappedclasses.transducerers.ICHTHYOP_MODEL_ONE_BY_ONE

#INPUT PARAMETERS#
id_drifter=63908
starting_point_latitude="-13.548"
starting_point_longitude="63.757"
starting_point_starting_date="2007-01-15"
trajectory_temporal_extent="193 day(s) 00 hour(s) 00 minute(s)"

#TEMPLATE TO FULFILL TO INVOKE THE ALGORITHM#
templateFile="TemplateIchtyopRequest.xml";

#CREATE NEW ON-THE-FLY VERSION OF THE TEMPLATE#
sentfile=paste("ichtyop_req_",Sys.time(),".xml",sep="")
sentfile<-gsub(":", "_", sentfile)
sentfile<-gsub(" ", "_", sentfile)

filexml<-readChar(templateFile, file.info(templateFile)$size)
filexml<-gsub("\r\n", "\n", filexml)

#FULFILL THE TEMPLATE#
filexml<-gsub("#id_drifter#", id_drifter, filexml)
filexml<-gsub("#starting_point_latitude#", starting_point_latitude, filexml)
filexml<-gsub("#starting_point_longitude#", starting_point_longitude, filexml)
filexml<-gsub("#starting_point_starting_date#", starting_point_starting_date, filexml)
filexml<-gsub("#trajectory_temporal_extent#", trajectory_temporal_extent, filexml)

filehandle <- file(filexml)
write(filexml, file = sentfile,append = FALSE, sep = "")
close(filehandle)

#CALL WPS VIA POST#
out<-POST(url = wps_uri, config=c(authenticate(username, token, type = "basic")),
          body = upload_file(sentfile, type="text/xml"),encode = c("multipart"), handle = NULL, timeout(3600))

#CHECK IF THE PROCESS HAS ALREADY FINISHED#
stop_condition_success<-grepl("Process successful",as.character(out))
stop_condition_fail<-grepl("Exception",as.character(out))

#GET THE STATUS LOCATION FROM THE ACCEPTANCE RESPONSE#
lout<-as.character(out)
print(lout)
statusLocation='statusLocation=\"'
endstatusLocation='">\n'
pos1 = regexpr(statusLocation, lout)
pos2 = regexpr(endstatusLocation, lout)
llout<-substr(lout, pos1+nchar(statusLocation), pos2-1)
print(llout)

#CHECK THE STATUS OF THE COMPUTATION UNTIL COMPLETION#
while (!stop_condition_fail && !stop_condition_success){
  print("Checking...")
  #CHECK THE STATUS URL#
  out1<-GET(url = llout, config=c(authenticate(username, token, type = "basic")),handle = NULL, timeout(3600))
  print(as.character(out1))
  stop_condition_success<-grepl("ProcessSucceeded",as.character(out1))
  stop_condition_fail<-grepl("Exception",as.character(out1))
  #SLEEP FOR 10 SECONDS BEFORE THE NEXT CHECK#
  Sys.sleep(10)
}

print(as.character(out1))
if (stop_condition_success){
  #PARSE THE OUTPUT IN THE CASE OF SUCCESS
  wps.output<-parseResponse(response=out1)
  output<-as.data.frame(wps.output)
  View(output)
}

closeAllConnections()



